<div class="container">
  <div class="row">
    <div class="col-md-6 offset-md-3">
      <h2>Angular 6 Reactive Form Validation</h2>
      <form [formGroup]="registerForm" (ngSubmit)="onSubmit()">
        <div class="form-group">
          <label>First Name</label>
          <input type="text" formControlName="firstName" class="form-control" />
          <div
            *ngIf="
              !registerForm.get('firstName').valid &&
              registerForm.get('firstName').touched
            "
            style="color: red"
          >
            First Name is required
          </div>
        </div>

        <div class="form-group">
          <label>Last Name</label>
          <input type="text" formControlName="lastName" class="form-control" />
          <div
            *ngIf="
              registerForm.get('lastName').invalid &&
              registerForm.get('lastName').touched
            "
            style="color: red"
          >
            Last Name is required
          </div>
        </div>

        <div class="form-group">
          <label>Email</label>
          <input type="text" formControlName="email" class="form-control" />
          <div
            *ngIf="
              registerForm.get('email').invalid &&
              registerForm.get('email').touched
            "
            style="color: red"
          >
            {{ this.getEmailErrorMessage() }}
          </div>
        </div>

        <div class="form-group">
          <label>Password</label>
          <input
            type="password"
            formControlName="password"
            class="form-control"
          />
          <div
            *ngIf="
              !!registerForm.get('password').errors?.required &&
              registerForm.get('password').touched
            "
            style="color: red"
          >
            Password Required
          </div>
          <div
            *ngIf="!!registerForm.get('password').errors?.minlength"
            style="color: red"
          >
            Password must contain atleast 6 characters
          </div>
        </div>

        <div class="form-group" style="display:inline-block">
          <label>From Date</label>
          <div class="input-group">
            <input
              class="form-control"
              placeholder="From"
              name="dp"
              ngbDatepicker
              #d="ngbDatepicker"
              formControlName="fromDate"
              [readOnly]="true"
              (ngModelChange)="setToDate()"
            />
            <div class="input-group-append">
              <button
                class="btn btn-outline-secondary calendar"
                (click)="d.toggle()"
                type="button"
              ></button>
            </div>
          </div>
        </div>
        <br />
        <div class="form-group" style="display:inline-block">
          <label>To Date</label>
          <div class="input-group">
            <input
              class="form-control"
              placeholder="To Date"
              name="dp"
              ngbDatepicker
              #d1="ngbDatepicker"
              formControlName="toDate"
              [disabled]="this.val"
              [readOnly]="true"
              [minDate]="this.minDate"
            />

            <div class="input-group-append">
              <button
                class="btn btn-outline-secondary calendar"
                (click)="d1.toggle()"
                type="button"
                [disabled]="this.val"
              ></button>
            </div>
          </div>
        </div>

        <div class="form-group" style="">
          <button class="btn btn-primary" type="submit">Register</button>
        </div>
      </form>
    </div>
  </div>
</div>
